//
//  Data+Extension.swift
//  AidlabSDK
//
//  Created by Szymon Gęsicki on 05/02/2021.
//  Copyright © 2020 Aidlab. All rights reserved.
//

import Foundation

extension Data {
    
    init<T>(values: [T]) {
        self.init()
        for var value in values {
            withUnsafePointer(to: &value) { self.append(UnsafeBufferPointer(start: $0, count: 1)) }
        }
    }
    
    func toArray<T>(type: T.Type) -> [T] where T: ExpressibleByIntegerLiteral {
        var array = Array<T>(repeating: 0, count: self.count/MemoryLayout<T>.stride)
        _ = array.withUnsafeMutableBytes { copyBytes(to: $0) }
        return array
    }
}
