enum BodyPosition { Undefined, Front, Back, LeftSide, RightSide }

extension BodyPositionExtension on BodyPosition {
  int get value {
    switch (this) {
      case BodyPosition.Undefined:
        return 0;
      case BodyPosition.Front:
        return 1;
      case BodyPosition.Back:
        return 2;
      case BodyPosition.LeftSide:
        return 3;
      case BodyPosition.RightSide:
        return 4;
    }
  }

  static BodyPosition fromValue(int value) {
    return BodyPosition.values.firstWhere((element) => element.value == value,
        orElse: () =>
            throw ArgumentError("Failed to parse from value: value: $value"));
  }
}
