enum DisconnectReason {
  Timeout,
  DeviceDisconnected,
  AppDisconnected,
  SdkOutdated,
  UnknownError,
}

extension DisconnectReasonExtension on DisconnectReason {
  int get value {
    switch (this) {
      case DisconnectReason.Timeout:
        return 0;
      case DisconnectReason.DeviceDisconnected:
        return 1;
      case DisconnectReason.AppDisconnected:
        return 2;
      case DisconnectReason.SdkOutdated:
        return 3;
      case DisconnectReason.UnknownError:
        return 4;
    }
  }

  static DisconnectReason fromValue(int value) {
    return DisconnectReason.values.firstWhere(
        (element) => element.value == value,
        orElse: () =>
            throw ArgumentError("Failed to parse from value: value: $value"));
  }
}
