enum EcgFiltrationMethod { normal, aggressive }

extension EcgFiltrationMethodExtension on EcgFiltrationMethod {
  int get value {
    switch (this) {
      case EcgFiltrationMethod.normal:
        return 0;
      case EcgFiltrationMethod.aggressive:
        return 1;
    }
  }

  static EcgFiltrationMethod fromValue(int value) {
    return EcgFiltrationMethod.values.firstWhere(
        (element) => element.value == value,
        orElse: throw ArgumentError(
            "Failed to parse EcgFiltrationMethod from value: value: $value"));
  }
}
