enum Exercise {
  PushUp,
  Jump,
  SitUp,
  Burpee,
  PullUp,
  Squat,
  PlankStart,
  PlankEnd
}

extension ExerciseExtension on Exercise {
  int get value {
    switch (this) {
      case Exercise.PushUp:
        return 0;
      case Exercise.Jump:
        return 1;
      case Exercise.SitUp:
        return 2;
      case Exercise.Burpee:
        return 3;
      case Exercise.PullUp:
        return 4;
      case Exercise.Squat:
        return 5;
      case Exercise.PlankStart:
        return 6;
      case Exercise.PlankEnd:
        return 7;
    }
  }

  static Exercise fromValue(int value) {
    return Exercise.values.firstWhere((element) => element.value == value,
        orElse: () =>
            throw ArgumentError("Failed to parse from value: value: $value"));
  }
}
