import 'package:aidlab_sdk/src/wrappers/aidlab_internal_delegate_wrapper.dart';
import 'package:aidlab_sdk/src/wrappers/aidlab_update_delegate_wrapper.dart';
import 'package:aidlab_sdk/src/wrappers/platform_aidlab_sdk.dart';
import '../../../aidlab_sdk.dart';

class InternalAidlab {
  final PlatformAidlab _platformAidlab;
  final AidlabInternalDelegateWrapper _internalDelegateWrapper;
  final AidlabUpdateDelegateWrapper _updateDelegateWrapper;

  set internalDelegate(InternalAidlabDelegate delegate) =>
      _internalDelegateWrapper.delegate = delegate;

  set updateDelegate(InternalAidlabUpdateDelegate delegate) =>
      _updateDelegateWrapper.delegate = delegate;

  InternalAidlab(
    PlatformAidlab platformAidlab,
    Aidlab aidlab,
  )   : _platformAidlab = platformAidlab,
        _internalDelegateWrapper = AidlabInternalDelegateWrapper(aidlab),
        _updateDelegateWrapper = AidlabUpdateDelegateWrapper(aidlab);

  void requestForFirmware(String url) {
    _platformAidlab.requestForFirmwareInfo(
      FirmwareInfoRequest()..url = url,
    );
  }

  void startFirmwareUpdate(String url, String updatableVersion) {
    _platformAidlab.startFirmwareUpdate(
      FirmwareUpdateRequest()
        ..url = url
        ..updatableVersion = updatableVersion,
    );
  }
}
