enum UpdateError {
  OldFirmware,
  CrcError,
  Stopped,
  Fail,
  UnknownResponse,
  DownloadFail
}

extension UpdateErrorExtension on UpdateError {
  int get value {
    switch (this) {
      case UpdateError.OldFirmware:
        return 0;
      case UpdateError.CrcError:
        return 1;
      case UpdateError.Stopped:
        return 2;
      case UpdateError.Fail:
        return 3;
      case UpdateError.UnknownResponse:
        return 4;
      case UpdateError.DownloadFail:
        return 5;
    }
  }

  static UpdateError fromValue(int value) {
    return UpdateError.values.firstWhere((element) => element.value == value,
        orElse: () =>
            throw ArgumentError("Failed to parse from value: value: $value"));
  }
}
