enum ScanMode {
  lowPower,
  aggressive,
}

extension ScanModeExtension on ScanMode {
  int get value {
    switch (this) {
      case ScanMode.lowPower:
        return 0;
      case ScanMode.aggressive:
        return 1;
    }
  }

  static ScanMode fromValue(int value) {
    return ScanMode.values.firstWhere((element) => element.value == value,
        orElse: () => throw ArgumentError(
            "Failed to parse ScanMode from value: value: $value"));
  }
}
