enum Signal {
  Ecg,
  Respiration,
  Temperature,
  Motion,
  Battery,
  Activity,
  Orientation,
  Steps,
  HeartRate,
  HealthThermometer,
  SoundVolume,
  Hrv,
  Pressure,
  SoundFeatures,
  RespirationRate,
  BodyPosition,
}

extension SignalExtension on Signal {
  int get value {
    switch (this) {
      case Signal.Ecg:
        return 0;
      case Signal.Respiration:
        return 1;
      case Signal.Temperature:
        return 2;
      case Signal.Motion:
        return 3;
      case Signal.Battery:
        return 4;
      case Signal.Activity:
        return 5;
      case Signal.Orientation:
        return 6;
      case Signal.Steps:
        return 7;
      case Signal.HeartRate:
        return 8;
      case Signal.HealthThermometer:
        return 9;
      case Signal.SoundVolume:
        return 10;
      case Signal.Hrv:
        return 11;
      case Signal.Pressure:
        return 12;
      case Signal.SoundFeatures:
        return 13;
      case Signal.RespirationRate:
        return 14;
      case Signal.BodyPosition:
        return 15;
    }
  }

  static Signal fromValue(int value) {
    return Signal.values.firstWhere((element) => element.value == value,
        orElse: () =>
            throw ArgumentError("Failed to parse from value: value: $value"));
  }
}
