enum SyncState { Start, End, Stop, Empty }

extension SyncStateExtension on SyncState {
  int get value {
    switch (this) {
      case SyncState.Start:
        return 0;
      case SyncState.End:
        return 1;
      case SyncState.Stop:
        return 2;
      case SyncState.Empty:
        return 3;
    }
  }

  static SyncState fromValue(int value) {
    return SyncState.values.firstWhere((element) => element.value == value,
        orElse: () =>
            throw ArgumentError("Failed to parse from value: value: $value"));
  }
}
