enum WearState { PlacedProperly, PlacedUpsideDown, Loose, Detached, Unknown }

extension WearStateExtension on WearState {
  int get value {
    switch (this) {
      case WearState.PlacedProperly:
        return 0;
      case WearState.PlacedUpsideDown:
        return 1;
      case WearState.Loose:
        return 2;
      case WearState.Detached:
        return 3;
      case WearState.Unknown:
        return 4;
    }
  }

  static WearState fromValue(int value) {
    return WearState.values.firstWhere((element) => element.value == value,
        orElse: () => throw ArgumentError(
            "Failed to parse WearState from value: value: $value"));
  }
}
