import '../../aidlab_sdk.dart';
import '../wrappers/platform_aidlab_sdk.dart';

class AidlabInternalDelegateWrapper implements PlatformAidlabInternalDelegate {
  final Aidlab aidlab;
  InternalAidlabDelegate? delegate;

  AidlabInternalDelegateWrapper(this.aidlab) {
    PlatformAidlabInternalDelegate.setup(this);
  }

  void release() {
    PlatformAidlabInternalDelegate.setup(null);
  }

  @override
  void didReceivePressure(PressureEvent arg) {
    delegate?.didReceivePressure(aidlab, arg.timestamp!, arg.values!.toList());
  }

  @override
  void pressureWearStateDidChange(PressureWearStateEvent arg) {
    delegate?.pressureWearStateDidChange(
        aidlab, WearStateExtension.fromValue(arg.wearState!));
  }

  @override
  void didReceiveFirmwareInformation(FirmwareInformationEvent arg) {
    delegate?.didReceiveFirmwareInformation(
        arg.updateAvailable!, arg.updatableVersion!);
  }
}
