import 'package:aidlab_sdk/src/api/internal/internal_aidlab_logger_delegate.dart';
import 'package:aidlab_sdk/src/wrappers/platform_aidlab_sdk.dart';

class AidlabLoggerDelegateWrapper implements PlatformAidlabLogger {
  final InternalAidlabLoggerDelegate loggerDelegate;

  AidlabLoggerDelegateWrapper._inner(this.loggerDelegate);

  static void listen(InternalAidlabLoggerDelegate delegate) {
    final wrapper = AidlabLoggerDelegateWrapper._inner(delegate);
    PlatformAidlabLogger.setup(wrapper);
  }

  static void release() {
    PlatformAidlabSdkDelegate.setup(null);
  }

  @override
  void onError(LogEvent arg) {
    loggerDelegate.onError(arg.msg!);
  }

  @override
  void onLog(LogEvent arg) {
    loggerDelegate.onLog(arg.msg!);
  }

  @override
  void onWarning(LogEvent arg) {
    loggerDelegate.onWarning(arg.msg!);
  }
}
