import 'package:aidlab_sdk/src/api/aidlab_sdk_delegate.dart';

import 'platform_aidlab_sdk.dart';

class AidlabSdkDelegateWrapper implements PlatformAidlabSdkDelegate {
  final AidlabSdkDelegate delegate;

  AidlabSdkDelegateWrapper._inner(this.delegate);

  static void listen(AidlabSdkDelegate delegate) {
    final wrapper = AidlabSdkDelegateWrapper._inner(delegate);
    PlatformAidlabSdkDelegate.setup(wrapper);
  }

  static void release() {
    PlatformAidlabSdkDelegate.setup(null);
  }

  @override
  void onAidlabDetected(AidlabDetectedEvent arg) {
    delegate.onAidlabDetected(arg.address!, arg.rssi!);
  }

  @override
  void onBluetoothStarted(EmptyEvent arg) {
    delegate.onBluetoothStarted();
  }

  @override
  void onDeviceScanStarted(EmptyEvent arg) {
    delegate.onDeviceScanStarted();
  }

  @override
  void onDeviceScanStopped(EmptyEvent arg) {
    delegate.onDeviceScanStopped();
  }

  @override
  void onScanFailed(ScanFailedEvent arg) {
    delegate.onScanFailed(arg.errorCode!);
  }
}
