import '../../aidlab_sdk.dart';
import '../wrappers/platform_aidlab_sdk.dart';

class AidlabUpdateDelegateWrapper implements PlatformAidlabUpdateDelegate {
  final Aidlab aidlab;
  InternalAidlabUpdateDelegate? delegate;

  AidlabUpdateDelegateWrapper(this.aidlab) {
    PlatformAidlabUpdateDelegate.setup(this);
  }

  static void release() {
    PlatformAidlabUpdateDelegate.setup(null);
  }

  @override
  void didFinishUpdate(EmptyEvent arg) {
    delegate?.didFinishUpdate();
  }

  @override
  void didReceiveUpdateError(UpdateEvent arg) {
    delegate?.didReceiveUpdateError(UpdateErrorExtension.fromValue(arg.error!));
  }

  @override
  void didReceiveUpdateProgress(UpdateProgress arg) {
    delegate?.didReceiveUpdateProgress(arg.progress!);
  }
}
