// @dart=2.9
import 'package:pigeon/pigeon.dart';
import 'empty_event.dart';

@FlutterApi()
abstract class PlatformAidlabInternalDelegate {
  void didReceiveFirmwareInformation(
      FirmwareInformationEvent firmwareInformationEvent);

  void didReceivePressure(PressureEvent pressureEvent);

  void pressureWearStateDidChange(PressureWearStateEvent wearStateEvent);
}

@FlutterApi()
abstract class PlatformAidlabUpdateDelegate {
  void didFinishUpdate(EmptyEvent nothing);

  void didReceiveUpdateError(UpdateEvent event);

  void didReceiveUpdateProgress(UpdateProgress progress);
}

class FirmwareInformationEvent {
  bool updateAvailable;
  String updatableVersion;
}

class PressureEvent {
  int timestamp;
  Int32List values;
}

class PressureWearStateEvent {
  int wearState;
}

class UpdateProgress {
  int progress;
}

class UpdateEvent {
  int error;
}
