// @dart=2.9
import 'package:pigeon/pigeon.dart';
import 'empty_event.dart';

/// Imports to force pigeon to generate all files
// ignore: unused_import
import 'aidlab.dart';

// ignore: unused_import
import 'aidlab_internal.dart';

void configurePigeon(PigeonOptions options) {
  options.dartOut = "lib/src/wrappers/platform_aidlab_sdk.dart";

  options.objcHeaderOut = "ios/Classes/AidlabFlutter.h";
  options.objcSourceOut = "ios/Classes/AidlabFlutter.m";

  options.javaOut =
      "android/src/main/kotlin/com/aidlab/aidlab_sdk/AidlabFlutter.java";
  options.javaOptions.package = "com.aidlab.aidlab_sdk";
}

@HostApi()
abstract class PlatformAidlabSdk {
  void init();

  void scanForDevices(ScanModeRequest scanMode);

  void stopDeviceScan();

  void connect(ConnectRequest request);
}

@FlutterApi()
abstract class PlatformAidlabSdkDelegate {
  void onBluetoothStarted(EmptyEvent voidEvent);

  void onDeviceScanStarted(EmptyEvent voidEvent);

  void onDeviceScanStopped(EmptyEvent voidEvent);

  void onScanFailed(ScanFailedEvent event);

  void onAidlabDetected(AidlabDetectedEvent event);
}

class ScanModeRequest {
  int mode;
}

class ConnectRequest {
  String address;
  Int32List signals;
}

class AidlabDetectedEvent {
  String address;
  int rssi;
}

class ScanFailedEvent {
  int errorCode;
}

@FlutterApi()
abstract class PlatformAidlabLogger {
  void onLog(LogEvent event);

  void onWarning(LogEvent event);

  void onError(LogEvent event);
}

class LogEvent {
  String msg;
}
